package com.example.calcolatrice;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.AbstractComponent;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.GridLayout;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.Panel;
import com.vaadin.ui.TextField;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("calcolatrice")
public class CalcolatriceUI extends UI {

	private TextField display;
	private Calcolatrice calcolatrice = new Calcolatrice();

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = CalcolatriceUI.class)
	public static class Servlet extends VaadinServlet {
	}

	@Override
	protected void init(VaadinRequest request) {
		final VerticalLayout layout = new VerticalLayout();
		layout.setMargin(true);
		setContent(layout);
		

		Label l = new Label("Questa è la mia calcolatrice");
		layout.addComponent(l);
		
		display = new TextField();
		display.setValue(calcolatrice.dammiDisplay());
		display.setSizeFull();
		display.addStyleName("rightalignment");
		layout.addComponent(display);
		
		Panel keyboard = new Panel();
		
		GridLayout keyboardLayout = new GridLayout(4, 4);
		keyboardLayout.setSizeFull();
		keyboard.setContent(keyboardLayout);
		
		Button[] bottone = new Button[16];
		for (int i = 0; i < bottone.length; i++) {
			bottone[i] = new Button();
			bottone[i].setSizeFull();
		}

		bottone[0].setCaption("0");
		keyboardLayout.addComponent(bottone[0], 0, 3);
		addListenerToButton(bottone[0]);
		int r = 3;
		for (int i = 1; i < 10; i++) {
			int c =(i-1)%3; 
			if(c==0 ) r--;
			bottone[i].setCaption(""+i);
			addListenerToButton(bottone[i]);
			keyboardLayout.addComponent(bottone[i], c, r);
		}
		
		bottone[10].setCaption("+");
		addListenerToButton(bottone[10]);
		keyboardLayout.addComponent(bottone[10], 3, 0);

		bottone[11].setCaption("-");
		addListenerToButton(bottone[11]);
		keyboardLayout.addComponent(bottone[11], 3, 1);
		
		bottone[12].setCaption("*");
		addListenerToButton(bottone[12]);
		keyboardLayout.addComponent(bottone[12], 3, 2);
		
		bottone[13].setCaption("/");
		addListenerToButton(bottone[13]);
		keyboardLayout.addComponent(bottone[13], 3, 3);
		
		bottone[14].setCaption("=");
		addListenerToButton(bottone[14]);
		keyboardLayout.addComponent(bottone[14], 2, 3);
		
		bottone[15].setCaption("C");
		addListenerToButton(bottone[15]);
		keyboardLayout.addComponent(bottone[15], 1, 3);
		
		layout.addComponent(keyboard);
		
		
//		Button button = new Button("Click Me");
//		button.addClickListener(new Button.ClickListener() {
//			public void buttonClick(ClickEvent event) {
//				layout.addComponent(new Label("Thank you for clicking"));
//			}
//		});
//		layout.addComponent(button);
	}
	
	void addListenerToButton(Button bottone){
		bottone.addClickListener(new Button.ClickListener() {
			@Override
			public void buttonClick(ClickEvent event) {
				String etichettaBottone = ((Button) event.getSource()).getCaption();
//				display.setValue(etichettaBottone);
				switch (etichettaBottone) {
				case "0":
					calcolatrice.premiZero();
					break;
				case "1":
					calcolatrice.premiUno();
					break;
				case "2":
					calcolatrice.premiDue();
					break;
				case "3":
					calcolatrice.premiTre();
					break;
				case "4":
					calcolatrice.premiQuattro();
					break;
				case "5":
					calcolatrice.premiCinque();
					break;
				case "6":
					calcolatrice.premiSei();
					break;
				case "7":
					calcolatrice.premiSette();
					break;
				case "8":
					calcolatrice.premiOtto();
					break;
				case "9":
					calcolatrice.premiNove();
					break;
				case "+":
					calcolatrice.premiSomma();
					break;
				case "-":
					calcolatrice.premiSottrazione();
					break;
				case "*":
					calcolatrice.premiProdotto();
					break;
				case "/":
					calcolatrice.premiDivisione();
					break;
				case "=":
					calcolatrice.premiUguale();
					break;
				case "C":
					calcolatrice.premiCancella();
					break;
				}
				display.setValue(calcolatrice.dammiDisplay());
			}
		});
	}

}